﻿using System;
using System.Linq.Expressions;

namespace ConsoleApplication1
{
    class Program
    {
        static void Main(string[] args)
        {
            Expression<Func<int, int, int>> exp = (a, b) => a + b;

            // 람다식의 본체의 루트는 2항 연산자인 + 기호
            BinaryExpression opPlus = exp.Body as BinaryExpression;
            Console.WriteLine(opPlus.NodeType);

            // 2항 연산자의 좌측 연산자
            ParameterExpression left = opPlus.Left as ParameterExpression;
            Console.WriteLine(left.NodeType + ": " + left.Name);

            // 2항 연산자의 우측 연산자
            ParameterExpression right = opPlus.Right as ParameterExpression;
            Console.WriteLine(right.NodeType + ": " + right.Name);

            Func<int, int, int> func = exp.Compile();
            Console.WriteLine(func(10, 2));

            // Expression 을 이용해 직접 구성한 식 트리
            ParameterExpression leftExp = Expression.Parameter(typeof(int), "a");
            ParameterExpression rightExp = Expression.Parameter(typeof(int), "b");
            BinaryExpression addExp = Expression.Add(leftExp, rightExp);

            Expression<Func<int, int, int>> addLambda = Expression<Func<int, int, int>>.Lambda<Func<int, int, int>>(
                addExp,
                new ParameterExpression[] { leftExp, rightExp });

            Console.WriteLine(addLambda.ToString());

            Func<int, int, int> addFunc = addLambda.Compile();
            Console.WriteLine(addFunc(10, 2));

            Expression.RuntimeVariables
        }
    }
}

